/*----------------------------------------
% description file: modeli
resp f;
var v;
varind x;
parresp ka,alpha;
pbisresp a0;
aux a1, a2, a3 ;
subroutine;
begin
a1 = a0-x-1/ka;
a2 = 4*a0/ka ;
a3= 0.5*(a1+(a1**2+a2)**(0.5));
f=alpha*a3;
v=1/(alpha**2);
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int modeli_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[3], da[3][2];
ECRTRACE("modeli");
for (i=0; i<nbl; i++)
  {
    res= ((g[0]) - (x[i][0])) - (mydiv(
      (double)1, t[0]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= mydiv(((double)4) * (g[0]), t[0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= ((double)5.00000000e-01) * ((a[0]) + (mypow((mypow(
      a[0], (double)2)) + (a[1]), 
      (double)5.00000000e-01)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[2]= res;
    res= (t[1]) * (a[2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= -(mydiv(-((double)1), mypow(t[0], 
      (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][0]= res;
    res= (double)0;
    da[0][1]= res;
    res= mydiv(-(((double)4) * (g[0])), mypow(t[0], 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][0]= res;
    res= (double)0;
    da[1][1]= res;
    res= ((double)5.00000000e-01) * ((da[0][0]) + ((
      (double)5.00000000e-01) * ((mypow((mypow(a[0], 
      (double)2)) + (a[1]), (
      (double)5.00000000e-01) - ((double)1))) * (((
      (double)2) * ((mypow(a[0], (
      (double)2) - ((double)1))) * (da[0][0]))) + (
      da[1][0])))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][0]= res;
    res= ((double)5.00000000e-01) * ((da[0][1]) + ((
      (double)5.00000000e-01) * ((mypow((mypow(a[0], 
      (double)2)) + (a[1]), (
      (double)5.00000000e-01) - ((double)1))) * (((
      (double)2) * ((mypow(a[0], (
      (double)2) - ((double)1))) * (da[0][1]))) + (
      da[1][1])))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][1]= res;
    res= (t[1]) * (da[2][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= ((t[1]) * (da[2][1])) + (a[2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
  }
return(OK);
}

short int vareli_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[3], da[3][2];
ECRTRACE("vareli");
for (i=0; i<nbl; i++)
  {
    res= mydiv((double)1, mypow(t[1], 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (double)0;
    dtv[i][0]= res;
    res= mydiv(-(((double)2) * (mypow(t[1], (
      (double)2) - ((double)1)))), mypow(
      mypow(t[1], (double)2), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
  }
return(OK);
}
