/*----------------------------------------
fichier de description: model

% modele CORTI
resp f; 
var v;
varind x; 
aux a1,a2; 
parresp n,d,a,b,g; 
pbisresp minf,pinf; 
pbisvar h;
subroutine;
begin 
a1= 1+exp(a+b*x); 
 
a2= if x==minf then d else 
      if x==pinf then n else 
      n+(d-n)*exp(-g*ln(a1))
    fi fi; 
 
f=a2; 
v=exp(h*ln(f));
end 
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[2], da[2][5];
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= ((double)1) + ((double)myexp((t[2]) + (
      (t[3]) * (x[i][0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= ((x[i][0]) == (g[0])) ? (t[1]) : (((x[i][0]) == (
      g[1])) ? (t[0]) : ((t[0]) + (((t[1]) - (t[0])) * (
      (double)myexp((-(t[4])) * (myln(a[0])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= a[1];
    f[i]= res;
    res= (double)0;
    da[0][0]= res;
    res= (double)0;
    da[0][1]= res;
    res= (double)myexp((t[2]) + ((t[3]) * (x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][2]= res;
    res= (x[i][0]) * ((double)myexp((t[2]) + ((t[3]) * (x[i][0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][3]= res;
    res= (double)0;
    da[0][4]= res;
    res= ((x[i][0]) == (g[0])) ? ((double)0) : (
      ((x[i][0]) == (g[1])) ? ((double)1) : ((
      (double)1) + ((((t[1]) - (t[0])) * (((-(t[4])) * (
      mydiv(da[0][0], a[0]))) * ((double)myexp((-(t[4])) * (
      myln(a[0])))))) + ((-((double)1)) * ((double)myexp(
      (-(t[4])) * (myln(a[0]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][0]= res;
    res= ((x[i][0]) == (g[0])) ? ((double)1) : (
      ((x[i][0]) == (g[1])) ? ((double)0) : (((
      (t[1]) - (t[0])) * (((-(t[4])) * (mydiv(da[0][1], a[0]))) * (
      (double)myexp((-(t[4])) * (myln(a[0])))))) + ((double)myexp(
      (-(t[4])) * (myln(a[0]))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][1]= res;
    res= ((x[i][0]) == (g[0])) ? ((double)0) : (
      ((x[i][0]) == (g[1])) ? ((double)0) : (((
      t[1]) - (t[0])) * (((-(t[4])) * (mydiv(da[0][2], a[0]))) * (
      (double)myexp((-(t[4])) * (myln(a[0])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][2]= res;
    res= ((x[i][0]) == (g[0])) ? ((double)0) : (
      ((x[i][0]) == (g[1])) ? ((double)0) : (((
      t[1]) - (t[0])) * (((-(t[4])) * (mydiv(da[0][3], a[0]))) * (
      (double)myexp((-(t[4])) * (myln(a[0])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][3]= res;
    res= ((x[i][0]) == (g[0])) ? ((double)0) : (
      ((x[i][0]) == (g[1])) ? ((double)0) : (((
      t[1]) - (t[0])) * ((((-(t[4])) * (mydiv(da[0][4], a[0]))) + (
      -(myln(a[0])))) * ((double)myexp((-(t[4])) * (myln(
      a[0])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][4]= res;
    res= da[1][0];
    df[i][0]= res;
    res= da[1][1];
    df[i][1]= res;
    res= da[1][2];
    df[i][2]= res;
    res= da[1][3];
    df[i][3]= res;
    res= da[1][4];
    df[i][4]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[2], da[2][5];
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= (double)myexp((g[0]) * (myln(f[i])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= ((g[0]) * (mydiv(df[i][0], f[i]))) * ((double)myexp((g[0]) * (
      myln(f[i]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][0]= res;
    res= ((g[0]) * (mydiv(df[i][1], f[i]))) * ((double)myexp((g[0]) * (
      myln(f[i]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
    res= ((g[0]) * (mydiv(df[i][2], f[i]))) * ((double)myexp((g[0]) * (
      myln(f[i]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][2]= res;
    res= ((g[0]) * (mydiv(df[i][3], f[i]))) * ((double)myexp((g[0]) * (
      myln(f[i]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][3]= res;
    res= ((g[0]) * (mydiv(df[i][4], f[i]))) * ((double)myexp((g[0]) * (
      myln(f[i]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][4]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
