#ifndef ERRCODESH
#define ERRCODESH

#define ERRV3   199  /* %Init3MCPT% The variance function cannot be calculated at the last
 estimated values of the parameters */
#define ERRVPUSS 159 /* %NLVCtxPuss% : The number of requested steps (%s%) must be positive and 
  less than %s%. */
#define ERRMODF 156 /* %CModErr% : The regression function could not be calculated
  at the starting values. */
#define ERRMODV 157 /* %CModErr% : The variance function could not be calculated
  at the starting values. */
#define ERRVAR1 158 /* %CVariance% : The %s%-st value calculated by the variance function is negative or null
  at the first iteration. */

#define NONFAIT 200 /* %PussIter%: nothing could be calculated  (see the warnings) */

/* PROMPT DES MESSAGES d"IMPRESSION INTERMEDIAIRE */
#define PROMPT "*"

/* MESSAGES d'IMPRESSION */
#define IMPDEBUT 1 /* code du message de NLEtape: debut d'etape */
#define IMPFIN 2   /* code du message de NLEtape: fin d'etape */
#define IMPDEBSUP 201 /* code du message de NLAutres: debut d'etape */
#define IMPFINSUP 202   /* code du message de NLAutres: fin d'etape */

/* messages de ErrIp */
#define IMPERRIP1 15
#define IMPERRIP2 3
#define IMPERRIP3 4 
/* messages de PussIp */
#define IMPIP0 5
#define IMPIP1 6
#define IMPIP2 7
#define IMPIP3 8
#define IMPIP4 10
#define IMPIP5 11
#define IMPIP6 12
#define IMPIP7 13
#define IMPIP8 14
/* messages de PussIpSedo */
#define IMPIP10 154 
#define IMPIP11 155
#define IMPIP12 198 
#define IMPIP13 197 
#define IMPIP14 196 


/* messages de PussIter */
#define IMPIT0 9 
#define IMPIT00 99 
#define IMPIT1 149
#define IMPIT2 17
#define IMPIT3 65
#define IMPIT4 74

/* messages de CCov2 et CCov3 */
#define IMPCOV 147

/* MESSAGES DE WARNING DE TYPE WNUMER */
/* Warnings de CModErr */
#define WARCM2 18 /* %CModErr% : The %s% model could not be calculated in step %s%. */
#define WARCM3 19 /* %CModErr% : 
  The maximal number of errors ("max.err.c1"= %s%) is reached. */
#define WARCM4 20 /* %CModErr% : %n%-st attempt at evaluating the model. */
/* warnings de PussIter */
#define WARPUSS1 21  /* %PussIter% 
  The model cannot be calculated: the maximum number of times the direction is 
  modified when the model cannot be calculated ("max.err.c1" = %s%) is reached.
 ( MaxErr atteint) */
#define WARPUSS2 22 /* %PussIter% : The maximal number of iterations ("max.iters" = %s%) is reached. */
#define WARPUSS3 23 /* %PussIter% : The maximal number of times ("max.err.c2" = %s%) for which the 
  minimisation criterion has been reached consecutively at the beginning of an 
  interval is reached. (MaxDeb atteint) */
#define WARPUSS4 61 /* %PussIter% : The minimisation criterions are equal at the 3 points of calculation,
  even after %s% ("max.err.c2") attempts.
(MaxLambda atteint) */


/* MESSAGES DE WARNING DE TYPE WMETHO */
/* warnings de NLVMod: incoherence between expressions of constraints */
#define WARVEGALP1 37
#define WARVEGALP2 38

/* warnings de NLVCtxPuss: affichage des valeurs par defaut */
#define WARVPUSS1 24
#define WARVPUSS2 25
#define WARVPUSS3 26
#define WARVPUSS4 27
#define WARVPUSS5 28
#define WARVPUSS6 29
#define WARVPUSS7 30
#define WARVPUSS8 31
#define WARVPUSS9 32
#define WARVPUSS10 33
#define WARVPUSS11 34
#define WARVPUSS12 161
#define WARMU1 35  /* warning de VerifMu */
#define WARMU2 36/* warning de VerifMu */
#define WARVPUSS16 39
#define WARVPUSS17 40
#define WARVPUSS18 162
#define WARVPUSS19 163

/* warnings de NLVCtxNum */
#define WARES1 41 
#define WARES2 42 
#define WARES3 43 
#define WARES4 44 
#define WARES5 45 
#define WARES6 46 
#define WARES7 47 
#define WARES8 48 
/* warnings de EstDefaut */
#define WARESD1 49
/* warnings de EstTheta */
#define WAREST1 50 
#define WAREST2 51 
#define WAREST3 52
#define WAREST4 53
#define WAREST5 60
/* warnings de EstSimul */
#define WARESS1 54
#define WARESS2 55
#define WARESS3 56
/* warnings de EstMien */
#define WARESM1 57
#define WARESM2 58
#define WARESM3 59
/* warnings de VerifMien */
#define WARVFM1 255
#define WARVFM2 256
#define WARVFM3 257
#define WARVFM4 258
#define WARVFM5 259


/* Dans NLVCtxInteg */
#define WAINDLO 310 /* erreur sur ImpInteg */
#define WARITOL 311
#define WARATOL 312
#define WARRTOL 313
#define WARJT 314
#define WARIOPT 315

/* MESSAGES D'ERREUR */
/* dans nlfonc.h */
#define WARNUM 188

/* Dans NLVDon.ChangerDim */
#define WARPOIDS2  62
/* tous les poids sont nuls */

/* dans VerifMu */
#define ERRMU 66
/* Dans NL */
#define ERRTRACE 112  /* LgTrace erronee */
 
/* Overflow dans ActAMod, ModAAct */
#define ERROVFL1 67
#define ERROVFL2 68
#define ERROVFL3 69
#define ERROVFL4 70
/* Overflow dans DModAAct */
#define ERROVFL5 16

#define ERRDIREC 71
/* %CDirec% : The %s%-st term of the diagonal of W is negative or null (%s%). */

#define ERRCALC 72
/* %MatInv% : We are trying to inverse a singular matrix. */

#define ERRSYS 73
/* %CDirGM% : The linear system cannot be solved. */

/* ...... les codes erreurs renvoyes par NLVDon et PreparVar ......... */
/* ................................................................... */
# define WARDON 76 /* la dimension d'une donnee est erronee               */
# define WARDON1 77 /* la dimension d'un composant X est erronee          */
# define WARDON2 78 /* la dimension d'un composant X est erronee          */
# define WARDON3 75 /* la dimension d'un composant X est erronee          */
# define WARDON4 89 /* la dimension d'un composant X est erronee          */
# define WARDON5 96 /* la dimension d'un composant X est erronee          */
# define WARPOIDS1 79 /* la %ieme valeur de PoidsT est negative           */

/* ...... les codes warning renvoyes par NLVMod ...................... */
/* ................................................................... */

# define WARVMOD1 90 /* On affecte la valeur CTE a Vari */
# define WARVMOD2 91 /* on ignore la fonction de calcul de v */
# define WARVMOD3 80 /* il faut qu'il y ait une fonction de calcul de v */
# define WARVMOD4 81 /* il faut qu'il y ait des parametres Beta */

# define WARVMOD5 82 /* Le nombre de valeurs initiales des parametres .. */
# define WARVMOD6 83 /* Le nombre de valeurs initiales des parametres bis */
# define WARVMOD7 84 /* Le nombre de valeurs de la contrainte .. */
# define WARVMOD9 86 /* La %s ieme valeur de la contrainte BInf .. */
# define WARVMOD10 87 /* La %s ieme valeur de la contrainte BSup .. */
# define WARVMOD11 88 /* La %s ieme valeur de la contrainte EgalN differente .. */
# define WARVMOD12 92 /* pas meme contrainte sur 2 param egaux */
# define WARVMOD13 93 /* quand il y a des Beta, il faut YaCalcV VRAI */
#define  WARVMOD14 94  /* La %s ieme valeur init differente ... */
#define  WARVMOD15 97 /* Binf = BSup */


/* ...... les codes erreurs renvoyes par NLVDonM...................... */
/* ................................................................... */

# define WARVDONM 95 /* Le nombre d'observations de la  courbe .. */

/* rajout d'un message de PussIp */
#define IMPIP9 98

/* messages de NLAutres.CCov2 */
#define WARCCOV2 101 /* On ne sait pas calculer la variance a l'etape 2 quand PCValEta # CEtamv */

/* messages de CCov3 */
#define WARCCOV3 102 /* On ne sait pas calculer la variance a l'etape 3 */

/* erreur de CMu */
#define ERRCMU 105 /* TypeMu non reconnu */

/* warnings de NLVCrole */
#define WARVCO1 110 /* element different de VRAI, FAUX */
#define WARVCO2 111 /* Entier erronee */

/* erreur dans NLVInit */
#define ERRVINIT 120
#define WARCONTB 121

/* warning dans NLAutres.CCorr */
#define WARCORR 127
/* warning dans NLautres.CVarZmv */
#define WARVARZ1 128
/* code d'erreur de CVariance: ValV <=0 */
#define ERRVAR 145

/* code d'erreur de PussIter */
#define ERRTYPES 148

/* codes d'erreur des modules d'integration */
#define  ERNBTHET 301 /* NbThetaSedo < 0 */
#define  ERTYPCI 302/* si le nombre de parametres dans le systeme est nul alors */
      /* les conditions initiales doivent etre des parametres */
#define ERINDLO 303   /* erreur sur IndicX  ou IndicCi*/
#define ERNBEQUA 304  /* pas ou trop d'equations (par rapport a BSUPFICT) */
#define  ERINITJ 305  /* erreur dans IndicTj */
#define ERLCI 306     /* erreur de longueur dans le vecteur des ci */
#define ERLSODA 307   /* erreur LSODA */

#define WALGTRACE 400 /* NLVTrace */
/* codes utilises dans GerMessage */
#define EPBALLOC 401
#define ERWT 402
#define ERWM 403
#define ERWA 404
#define ERWI 405
#define ERWN 406
#endif
