/*----------------------------------------
% description file: modscat
resp f;
var v;
varind x;
parresp k1,r0;
aux a1, a2, a3 ;
subroutine;
begin
a1 = r0+1/k1+x;
a2 = 4*r0/k1;
a3=((r0-1/k1-x)**2+a2)**(0.5);
f=(a1-a3)/2;
v=f**2;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int modscat_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[3], da[3][2];
ECRTRACE("modscat");
for (i=0; i<nbl; i++)
  {
    res= ((t[1]) + (mydiv((double)1, t[0]))) + (
      x[i][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= mydiv(((double)4) * (t[1]), t[0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= mypow((mypow(((t[1]) - (mydiv(
      (double)1, t[0]))) - (x[i][0]), 
      (double)2)) + (a[1]), 
      (double)5.00000000e-01);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[2]= res;
    res= mydiv((a[0]) - (a[2]), (double)2);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= mydiv(-((double)1), mypow(t[0], 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][0]= res;
    res= (double)1;
    da[0][1]= res;
    res= mydiv(-(((double)4) * (t[1])), mypow(t[0], 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][0]= res;
    res= mydiv(((double)4) * (t[0]), mypow(t[0], 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][1]= res;
    res= ((double)5.00000000e-01) * ((mypow((mypow(((t[1]) - (
      mydiv((double)1, t[0]))) - (x[i][0]), 
      (double)2)) + (a[1]), (
      (double)5.00000000e-01) - ((double)1))) * (((
      (double)2) * ((mypow(((t[1]) - (mydiv(
      (double)1, t[0]))) - (x[i][0]), (
      (double)2) - ((double)1))) * (-(
      mydiv(-((double)1), mypow(t[0], 
      (double)2)))))) + (da[1][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][0]= res;
    res= ((double)5.00000000e-01) * ((mypow((mypow(((t[1]) - (
      mydiv((double)1, t[0]))) - (x[i][0]), 
      (double)2)) + (a[1]), (
      (double)5.00000000e-01) - ((double)1))) * (((
      (double)2) * (mypow(((t[1]) - (mydiv(
      (double)1, t[0]))) - (x[i][0]), (
      (double)2) - ((double)1)))) + (da[1][1])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][1]= res;
    res= mydiv(((da[0][0]) - (da[2][0])) * (
      (double)2), mypow((double)2, 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= mydiv(((da[0][1]) - (da[2][1])) * (
      (double)2), mypow((double)2, 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
  }
return(OK);
}

short int varscat_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[3], da[3][2];
ECRTRACE("varscat");
for (i=0; i<nbl; i++)
  {
    res= mypow(f[i], (double)2);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= ((double)2) * ((mypow(f[i], (
      (double)2) - ((double)1))) * (df[i][0]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][0]= res;
    res= ((double)2) * ((mypow(f[i], (
      (double)2) - ((double)1))) * (df[i][1]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
  }
return(OK);
}
