
/*--------------- COPYRIGHT ------------------------
| INRA - Laboratoire de Biometrie de Jouy en Josas |
--------------------------------------------------*/
/*--------------- INCLUDES -----------------------*/
#include <stdio.h>
#include <math.h>

#include "nltypes.h"
#include "nlcodes.h"
#include "errcodes.h"
#include "nlmacros.h"
#include "nlchoix.h"
#include "nlglobal.h"


/*--------------- VARIABLES EXTERNES -------------*/


/* les arguments de NL: */
#include "nldcl.h"  

/*----------------FONCTIONS EXTERNES ------------*/
void NLDetru(TDonnees *Donnees, TModele *Modele, TCtxPuss *CtxPuss, TCtxNum CtxNum[],
             TParam Theta[], TParam Beta[], TResStat ResStat[],
             TShortInt NbItSv[MAXETAP], 
	     TResStat ItStat[MAXETAP][MAXSVIT], 
	     TVect ItTheta[MAXETAP][MAXSVIT], TVect ItBeta[MAXETAP][MAXSVIT],
	     TVect ItDirec[MAXETAP][MAXSVIT]);

/*--------------- Identification fonction ----------
| Nom de la fonction    : delnls2                |
| Role                  : appeler le programme     |
|                         de destruction des       |
|                       structures allouees par NL |
| Parametres de sortie  :                          |
|   neant
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :  del...
| Fonctions appelantes :  la fonction S: delnls2      |
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

void delnls2()

{
NLDetru(&Donnees, &Modele, &CtxPuss, CtxNum,
              Theta, Beta, ResStat,
             NbItSv,  ItStat, ItTheta, ItBeta, ItDirec);
return;
}
